using System.Reflection;
using HarmonyLib;
using Vintagestory.API.Common;
using Vintagestory.API.Common.Entities;

namespace CooperativeCombatMod {
	public class CooperativeCombatSystem: ModSystem {
		public const string activityId = "cc-";
		public const int invulTime = 500;
		protected const string harmonyId = "cooperativecombat";

		protected Harmony harmony;

		public override void Start(ICoreAPI api) {
			base.Start(api);

			this.harmony = new Harmony(harmonyId);
			this.harmony.PatchAll(Assembly.GetExecutingAssembly());
		}

		public override void Dispose() {
			base.Dispose();

			this.harmony.UnpatchAll(harmonyId);
		}
	}

	[HarmonyPatch(typeof(EntityAgent), "ReceiveDamage")]
	public class CC_EA_ReceiveDamage {
		static void Prefix(ref EntityAgent __instance, DamageSource damageSource, float damage) {
			if(__instance is EntityPlayer) {
				// Do not change players' invulnerability frames.
				return;
			}

			Entity attacker = damageSource.GetCauseEntity();

			if(attacker == null
					|| !(attacker is EntityPlayer)) {
				// Do not change behaviour of non-player damage sources.
				return;
			}

			if(!__instance.IsActivityRunning(CooperativeCombatSystem.activityId + attacker.EntityId)) {
				// Player's cooldown is ready, bypass target's invulnerability.
				__instance.SetActivityRunning("invulnerable", -1);
				__instance.SetActivityRunning(CooperativeCombatSystem.activityId + attacker.EntityId, CooperativeCombatSystem.invulTime);
			}
		}
	}
}